panelLabel=function(text) mtext(text,side=3,adj=0,cex=1.25,line=0.5); 

retroSmooth=function(x1,y1,x2,y2) { 
  xmin=max(min(x1),min(x2));
  xmax=min(max(x1),max(x2)); 
  px=seq(xmin,xmax,length=100); 	
  
  smoothy1=smooth.spline(x1,sqrt(y1)); 
  maxdf=0.67*length(x1); 
  if(smoothy1$df>maxdf) smoothy1=smooth.spline(x1,sqrt(y1),df=maxdf); 
  mindf=0.25*length(x1); 
  if(smoothy1$df<mindf) smoothy1=smooth.spline(x1,sqrt(y1),df=mindf); 
  y1s=predict(smoothy1,data.frame(x1=px))$y^2;  
  
  smoothy2=smooth.spline(x2,sqrt(y2)); 
  maxdf=0.67*length(x2); 
  if(smoothy2$df>maxdf) smoothy2=smooth.spline(x2,sqrt(y2),df=maxdf); 
  mindf=0.25*length(x2); 
  if(smoothy2$df<mindf) smoothy2=smooth.spline(x2,sqrt(y2),df=mindf); 
  y2s=predict(smoothy2,data.frame(x2=px))$y^2;  
  
  return(list(px=px,y1s=y1s,y2s=y2s))
}  
 
######### Fig1
graphics.off(); 
win.graph(7.5,8); 
par(mfrow=c(3,2),mar=c(4,5,3,3),cex.lab=1.5,cex.axis=1.35,las=1,lwd=1,mgp=c(2.5,1,0));

d5g2<-as.matrix(read.table("d5g2.txt",skip=1)); 
x=d5g2[-1,-2]; out=retroSmooth(x[,1],x[,2],x[,1],x[,3]); 
plot(x[,1],x[,2],type="o",pch=1,xlab=" ",ylab=expression(paste("Algae(",10^6,"cells/ml)")), 
cex=1.4,ylim=c(0,4),col="forestgreen",lwd=2,lty=2);
points(out$px,out$y1s,type="l",col="forestgreen",lty=1,lwd=2); 
par(new=T,yaxt="s")
plot(x[,1],x[,3],type="o",col="red", axes=F, bty="n", lwd=2,xlab="Time (d)", ylab="",ylim=c(0,25),
cex=1.4,pch=16,lty=2)
points(out$px,out$y2s,type="l",col="red",lty=1,lwd=2); 
axis(4, at=pretty(0:25))
title("Several algal clones",line=0.5,cex.main=1.5); 
panelLabel("(a)"); 
Yoshida.mult=x; Yoshida.mult.smooth=out;

x=read.csv("OrangeOneClone.csv"); 
x[,1]=x[,1]-min(x[,1]);
x=x[6:36,];out=retroSmooth(x[,1],x[,2],x[,1],x[,3]); 
par(mar=c(4,3,3,5));
plot(x[,1],x[,2],type="o",pch=1,xlab="Time (d)", ylab="",cex=1.4,ylim=c(0,2),col="forestgreen",
	lwd=2,lty=2); 
points(out$px,out$y1s,type="l",col="forestgreen",lty=1,lwd=2); 	
par(new=T)
plot(x[,1],x[,3],type="o",col="red", axes=F, bty="n",lwd=2, xlab="", ylab="",ylim=c(0,25),
	cex=1.4,pch=16,lty=2)
points(out$px,out$y2s,type="l",col="red",lty=1,lwd=2); 
axis(4, at=pretty(0:25))
par(las=0);
mtext("Rotifers (females/ml)", 4, 3,cex=1); 
title("One algal clone",line=0.5,cex.main=1.5); 
panelLabel("(b)"); 
Yoshida.one=x; Yoshida.one.smooth=out;

par(mar=c(4,5,3,3));
e=Yoshida.mult.smooth$px>10;
plot(Yoshida.mult.smooth$y1[e],Yoshida.mult.smooth$y2[e],type="l",col="black",
xlab="Algae",ylab="Rotifers",lwd=2);
prey=Yoshida.mult.smooth$y1[e]; prey=prey/sd(prey); 
pred=Yoshida.mult.smooth$y2[e]; pred=pred/sd(pred);
out=princomp(x=cbind(prey,pred));
EDI=out$sdev[2]/out$sdev[1]; 
legend("bottomleft",paste("EDI=",round(EDI,digits=2)),cex=1.6,bty="n"); 
panelLabel("(c)"); 


par(mar=c(4,3,3,5));
e=Yoshida.one.smooth$px>15;
plot(Yoshida.one.smooth$y1[e],Yoshida.one.smooth$y2[e],type="l",col="black",xlab="Algae",ylab=" ",lwd=2);
prey=Yoshida.one.smooth$y1[e]; prey=prey/sd(prey); 
pred=Yoshida.one.smooth$y2[e]; pred=pred/sd(pred);
out=princomp(x=cbind(prey,pred));
EDI=out$sdev[2]/out$sdev[1]; 
legend("bottomright",paste("EDI=",round(EDI,digits=2)),cex=1.6,bty="n"); 
panelLabel("(d)"); 

Vibrio=read.csv("Dulos-Marchand-Vibrio.csv"); 
Ecoli=read.csv("Dulos-Marchand-Ecoli.csv"); 
out=retroSmooth(Ecoli$time,Ecoli$Prey,Vibrio$time,Vibrio$Predator); 
par(mar=c(4,5,4,3));
plot(Ecoli$time,Ecoli$Prey,type="o",pch=1,xlab="Time (d)", cex=1.4,
	col="forestgreen",lwd=2,lty=2,ylim=c(4,9),ylab="log10 Population/ml"); 
points(out$px,out$y1s,type="l",col="forestgreen",lty=1,lwd=2); 	
points(Vibrio$time,Vibrio$Predator,type="o",pch=16,cex=1.4,
	col="red",lwd=2,lty=2); 
points(out$px,out$y2s,type="l",col="red",lty=1,lwd=2); 
title("Dulos & Marchand 1984",line=0.5,cex.main=1.5); 
panelLabel("(e)"); 


# Sudo 
# P = Colpidium campylum (ciliate, predator), X=Alcaligenes faecalis (bacteria,prey)
P=read.table("SudoP.txt"); names(P)<-c("time","Predator");
X=read.table("SudoX.txt"); names(X)<-c("time","Prey");

out=retroSmooth(X$time,X$Prey,P$time,P$Predator); 
par(mar=c(4,4,4,5));
plot(X$time,X$Prey,type="o",pch=1,xlab="Time (hr)", ylab="Bacteria (mg/l)",cex=1.4,col="forestgreen",
	lwd=2,lty=2,ylim=c(0,70)); 
points(out$px,out$y1s,type="l",col="forestgreen",lty=1,lwd=2); 	
par(new=T)
plot(P$time,P$Predator,type="o",col="red", axes=F, bty="n",lwd=2, xlab="", ylab="",ylim=c(0,20),
	cex=1.4,pch=16,lty=2)
points(out$px,out$y2s,type="l",col="red",lty=1,lwd=2); 
axis(4, at=pretty(0:20))
par(las=0);
mtext("Ciliates (mg/l)", 4, 3,cex=1); 
title("Sudo et al. 1975",line=0.5,cex.main=1.5); 
Sudo=x; Sudo.smooth=out;
panelLabel("(f)"); 

