ICtypeII=function(t,X,parms) {
    X1=pmax(X,0); delta=parms[1]; 
	x=A=X1[1]; y=R=X1[2]; z=F=X1[3]; 
    S = max(0,1 - sum(X1));
	Rden=kR + A + aF*F;
	Fden=1+aA*A; 
	Adot=A*(r*S/(kA+S)- g*R/Rden - h*F/Fden - delta); # prey
	Rdot=R*(g*A/Rden + eta*F/Rden - delta); 	#predator 1 (top)
	Fdot=F*(h*A/Fden - eta*R/Rden - delta)+Iflag;	#predator 2 (intermed) 
	dx=c(Adot,Rdot,Fdot); dx[X<0]=0; 
	return(list(xdot=dx,c(x=x,y=y,z=z,S=S)))
}

Dynamics.plot=function(new=FALSE,delta=1,plot.z=TRUE,scalepops=TRUE) { 
########## Solve the model 
	tvals=seq(0,1000,by=.25); 
	y0=c(0.5*runif(1),0.25*runif(2)); 
	out=lsoda(y0,times=tvals,fun=ICtypeII,parms=delta); 
	prey=out[,2]; yzw=out[,-(1:2)]; 
	
	pj=which(peaks(yzw[,1])==TRUE);
	period1=mean(tail(diff(pj)))*(tvals[2]-tvals[1])
	
	y.out=acf(out[,"y"],lag.max=length(tvals)/2,plot=FALSE);
	period2=min(which(peaks(as.vector(y.out$acf))==TRUE))*(tvals[2]-tvals[1]);
	period=max(period1,period2); 
	plottime=70; 


	######### plot the populations 
	e=tvals>(max(tvals)-plottime); tmin=min(tvals[e]); tvals=tvals-tmin; 
	predcols=1:ifelse(plot.z,2,1); 
	
	X=cbind(prey[e],yzw[e,predcols]); 
	if(scalepops) {
		X=scale(X, center = FALSE, scale = apply(X,2,max))
	}	
	
	par(yaxt="n");
	matplot(tvals[e],X,type="l",lty=1,lwd=2,col=c("green4","red","purple"),
		xlab=" ",ylab="Scaled populations",bty="l",ylim=c(0,1.1));
    par(yaxt="s"); 
	axis(side=2,at=c(0,.5,1),labels=c("0","0.5","1")); 
	
	te=tvals[e]; 
	ee=(te%%2==0); 
	matpoints(te[ee],X[ee,],type="p",lwd=2,pch=c(1,16,17),cex=1.5,col=c("green4","red","purple")); 
    return(out) 
} 

phaselag=function(x,y) {
# how much does y lag x? 
	xpeaks=which(peaks(x)==TRUE); 
	ypeaks=which(peaks(y)==TRUE); 
	T=0.5*(mean(diff(xpeaks))+mean(diff(ypeaks)));
	ylast=max(ypeaks);
	xlast=max(xpeaks[xpeaks<ylast]);
	return( (ylast-xlast)/T );
}

## Returns vector of length=length(x) with TRUE at indices
## where x has a peak, FALSE where there is no peak
peaks<-function(x) {
  out=findpeaks(x); 
  z=rep(FALSE,length(x)); 
  z[out[,2]] <- TRUE;
  return(z); 
}
